unit BProcsPack;

interface
uses windows,kol,BmaxGTypes;
type TProcPack=class
   lastfunc:integer;
   constructor create;
   function SeaUnitTCost(TerrType:terrtpes):integer;
   function SeaBeachUnitTCost(TerrType:terrtpes):integer;
   function LandUnitTCost(TerrType:terrtpes):integer;
   function LandBeachUnitTCost(TerrType:terrtpes):integer;
   function AmphibiaUnitTCost(TerrType:terrtpes):integer;
   function SurveyorUnitTCost(TerrType:terrtpes):integer;
   function AirUnitTCost(TerrType:terrtpes):integer;
   function SeaStructureTCost(TerrType:terrtpes):integer;
   function SeaMineTCost(TerrType:terrtpes):integer;
   function LandStructureTCost(TerrType:terrtpes):integer;
   function ConnectorTCost(TerrType:terrtpes):integer;

   function StandartObtacle(TerrBefore:terrtpes):terrtpes;
   function NoObtacle(TerrBefore:terrtpes):terrtpes;
   function BridgeObtacle(TerrBefore:terrtpes):terrtpes;
   function WatrPlatformObtacle(TerrBefore:terrtpes):terrtpes;
   function RoadObtacle(TerrBefore:terrtpes):terrtpes;
   function Size1x1:TMGSize;
   function Size2x2:TMGSize;
   function Res(res:string;qty:word=0):TMxRes;
   function MineBuySell(buy:boolean=true;qty:word=1):boolean;
   function StandartBuySell(buy:boolean=true;qty:word=1):boolean;
   function NoBuyButSell(buy:boolean=true;qty:word=1):boolean;
   function StandartIcon(name:string='';size:word=64;color:cardinal=clGray;mode:string=''):Pbitmap;

   procedure StandartIconDraw(Objs:array of PObj);
   procedure UnloadPokupkaClick(Objs:array of PObj);
   procedure DrawIconOnRepaint(Objs:array of PObj);
   procedure DrawIconEverytime(Objs:array of PObj);

   procedure SelectUnloadedPokupka(Objs:array of PObj);
   procedure GetBackUnloadedPokupka(Objs:array of PObj);
   procedure SelectMyUnit(Objs:array of PObj);

   function GetLastFuncName:string;
   function getMaxGFunc(id:word):TMaxGFunc;
end;
var ppck:TProcPack;
function maxgfunc2stream(f:TMaxGFunc;strm:Pstream):word;
function Stream2maxgfunc(strm:PStream):TMaxGFunc;
procedure setfunc(f:MaxFuncArray;fkind:byte;newFunc:TMaxGFunc);
function getfunc(f:MaxFuncArray;fkind:byte):TMaxGFunc;
procedure EmptyFunc(var f:MaxFuncArray);
function copyFunc(FFrom:MaxFuncArray;FTo:MaxFuncArray):TMaxGFunc;
procedure MaxFuncArray2Stream(f:MaxFuncArray;strm:Pstream);
procedure Stream2MaxFuncArray(f:MaxFuncArray;strm:Pstream);
implementation
uses BMaxGDraw, BMaxGUnitsInfo, BmaxGPlayer, BmaxGGameMap, BMaxGObject, BMaxGGame;

procedure Stream2MaxFuncArray(f:MaxFuncArray;strm:Pstream);
var f1:integer;
begin
EmptyFunc(f);
strm.Read(f.count,sizeof(f.count));
setlength(f.procs,(f.count+1));
for f1:=0 to f.count do begin
   strm.Read(f.procs[f1].kind,1);
   f.procs[f1].proc:=Stream2maxgfunc(strm);
end;
end;
procedure MaxFuncArray2Stream(f:MaxFuncArray;strm:Pstream);
var f1:integer;
begin
strm.Write(f.count,sizeof(f.count));
for f1:=0 to f.count do begin
   strm.Write(f.procs[f1].kind,1);
   maxgfunc2stream(f.procs[f1].proc,strm);
end;
end;
function copyFunc(FFrom:MaxFuncArray;FTo:MaxFuncArray):TMaxGFunc;
var f1:integer;
begin
EmptyFunc(FTo);
setlength(FTo.procs,FFrom.count+1);
FTo.count:=FFrom.count;
for f1:=0 to FFrom.count do begin
   FTo.procs[f1].kind:=FFrom.procs[f1].kind;
   FTo.procs[f1].proc:=FFrom.procs[f1].proc;
end;
end;
procedure EmptyFunc(var f:MaxFuncArray);
var f1:integer;
begin
if f.count>=0 then begin
   for f1:=0 to f.count do
     f.procs[f1].proc:=nil;
end;
setlength(f.procs,0);
f.count:=-1;
end;
function getfunc(f:MaxFuncArray;fkind:byte):TMaxGFunc;
var f1:integer;
begin
result:=nil;
if f.count>=0 then begin
   for f1:=0 to f.count do
     if f.procs[f1].kind=fkind then result:=f.procs[f1].proc;
end;
end;
procedure setfunc(f:MaxFuncArray;fkind:byte;newFunc:TMaxGFunc);
var f1,f3:integer;
begin
f3:=-1;
if f.count>=0 then begin
   for f1:=0 to f.count do
     if f.procs[f1].kind=fkind then f3:=f1;
end;
if f3=-1 then begin
   f3:=f.count+1;
   setlength(f.procs,f3+1);
   f.count:=f3;
end;
f.procs[f3].proc:=newFunc;
end;

function Stream2maxgfunc(strm:PStream):TMaxGFunc;
var w:word;
begin
strm.Read(w,2);
result:=ppck.getMaxGFunc(w);
end;
function maxgfunc2stream(f:TMaxGFunc;strm:Pstream):word;
var w:word;
var tob:array of PObj;
begin
   if assigned(f) then begin
      setlength(Tob,0);
      f(Tob);
      w:=word(ppck.lastfunc);
   end else w:=0;
   if strm<>nil then strm.Write(w,2);
   Tob:=nil;
   result:=w;
end;
function TProcPack.AirUnitTCost(TerrType: terrtpes): integer;
begin
lastfunc:=7;
result:=4;
end;

function TProcPack.AmphibiaUnitTCost(TerrType: terrtpes): integer;
begin
lastfunc:=5;

result:=-1;
if TerrType[3]>0 then exit;
if TerrType[0]>0 then result:=12;
if TerrType[1]>0 then result:=4;
if TerrType[5]>0 then result:=4;
if TerrType[2]>0 then result:=4;
if TerrType[4]>0 then result:=4;
if TerrType[6]>0 then result:=2;

end;

function TProcPack.BridgeObtacle(TerrBefore: terrtpes): terrtpes;
begin
lastfunc:=15;
result:=TerrBefore;
result[0]:=0;
result[4]:=1;
end;

function TProcPack.ConnectorTCost(TerrType: terrtpes): integer;
begin
lastfunc:=11;

result:=-1;
if TerrType[3]>0 then exit;
if TerrType[5]>0 then exit;
if TerrType[4]>0 then exit;

if TerrType[0]>0 then result:=4;
if TerrType[1]>0 then result:=4;
if TerrType[2]>0 then result:=4;
if TerrType[6]>0 then result:=4;

end;

constructor TProcPack.create;
begin
lastfunc:=0;
end;

procedure TProcPack.DrawIconEverytime(Objs: array of PObj);
var drw:PBmaxDraw;
var mcl:PGameMapCell;
var pict:Pbitmap;
var tr:Trect;
var pixpos:TXY;
var unt:PMaxGoldObject;
var mmp:PGamemap;
begin
lastfunc:=28;
if high(objs)<0 then exit;

unt:=PMaxGoldObject(Objs[2]);
drw:=PBmaxDraw(Objs[0]);if drw.repaint=true then exit;
mcl:=PGameMapCell(Objs[1]);
if not(unt.here(mcl.selfpos))then exit;
mmp:=PGamemap(glsr[IDGameMap]);
pict:=unt.allinfo.info.icon;
if mmp.mask<>nil then
   if mmp.mask.p[mcl.selfpos.x,mcl.selfpos.Y]=1 then pict:=unt.allinfo.info.fwicon else
    if mmp.mask.p[mcl.selfpos.x,mcl.selfpos.Y]=2 then pict:=unt.allinfo.info.ricon;
pixpos:=drw.cellpos2pix(mcl.selfpos);
tr:=makerect(pixpos.x,
             pixpos.y,
             pixpos.x+trunc(pict.Width*drw.cellw/64),
             pixpos.y+trunc(pict.Height*drw.cellw/64));
pict.StretchDraw(drw.flipscreen.canvas.Handle,tr);
   if unt.selected then begin
      drw.flipscreen.Canvas.Pen.Color:=clLime;
      drw.flipscreen.Canvas.Brush.BrushStyle:=bsClear;
      drw.flipscreen.Canvas.Rectangle(tr.Left,tr.Top,tr.Right,tr.Bottom);
   end;
end;

procedure TProcPack.DrawIconOnRepaint(Objs: array of PObj);
var drw:PBmaxDraw;
var mcl:PGameMapCell;
var mmp:PGamemap;
var unt:PMaxGoldObject;
var pict:Pbitmap;
var tr:Trect;
var pixpos:TXY;
begin
lastfunc:=27;
if high(objs)<0 then exit;

unt:=PMaxGoldObject(Objs[2]);
mcl:=PGameMapCell(Objs[1]);
if not(unt.here(mcl.selfpos))then exit;
drw:=PBmaxDraw(Objs[0]);
pixpos:=drw.cellpos2pix(mcl.selfpos);
mmp:=PGamemap(glsr[IDGameMap]);
pict:=unt.allinfo.info.icon;
if mmp.mask<>nil then
   if mmp.mask.p[mcl.selfpos.x,mcl.selfpos.Y]=1 then pict:=unt.allinfo.info.fwicon else
    if mmp.mask.p[mcl.selfpos.x,mcl.selfpos.Y]=2 then pict:=unt.allinfo.info.ricon;
tr:=makerect(pixpos.x,
             pixpos.y,
             pixpos.x+trunc(pict.Width*drw.cellw/64),
             pixpos.y+trunc(pict.Height*drw.cellw/64));
if drw.repaint=false then begin
   if unt.selected then begin
      drw.flipscreen.Canvas.Pen.Color:=clLime;
      drw.flipscreen.Canvas.Brush.BrushStyle:=bsClear;
      drw.flipscreen.Canvas.Rectangle(tr.Left,tr.Top,tr.Right,tr.Bottom);
   end;
   exit;
end;
pict.StretchDraw(drw.outscreen.canvas.Handle,tr);
end;

procedure TProcPack.GetBackUnloadedPokupka(Objs: array of PObj);
var unt:PMaxGoldObject;
var plr:PNewPlayer;
var gm:PnewGame;
var f1:integer;
begin
{$IFDEF BMGLOG}log('procedure TProcPack.GetBackUnloadedPokupka(Objs: array of PObj);');{$ENDIF}
lastfunc:=30;
if high(objs)<0 then exit;
unt:=PMaxGoldObject(objs[IDUnit]);
plr:=PnewPlayer(objs[IDCurPlayer]);
if plr<>unt.player then exit;
gm:=PNewGame(glsr[IDGame]);
f1:=plr.addPokupka(unt.Allinfo,false,false);
plr.Pokupki[f1].gruz:=unt.params.gruz;
gm.Allunit.DestroyUnitForPlayer(plr,unt);
plr.pokupkiToKolListBox(PControl(glsr[IDCtrl]));
plr.units.deselectALL;
PBMaxDraw(objs[IDMdraw]).draw(true);

end;

function TProcPack.GetLastFuncName: string;
begin
result:='ppck.?';
if lastfunc= 1 then result:='SeaUnitTCost';
if lastfunc= 2 then result:='SeaBeachUnitTCost';
if lastfunc= 3 then result:='LandUnitTCost';
if lastfunc= 4 then result:='LandBeachUnitTCost';
if lastfunc= 5 then result:='AmphibiaUnitTCost';
if lastfunc= 6 then result:='SurveyorUnitTCost';
if lastfunc= 7 then result:='AirUnitTCost';
if lastfunc= 8 then result:='SeaStructureTCost';
if lastfunc= 9 then result:='SeaMineTCost';
if lastfunc=10 then result:='LandStructureTCost';
if lastfunc=11 then result:='ConnectorTCost';
if lastfunc=12 then result:='?Unused?';

if lastfunc=13 then result:='StandartObtacle';
if lastfunc=14 then result:='NoObtacle';
if lastfunc=15 then result:='BridgeObtacle';
if lastfunc=16 then result:='WatrPlatformObtacle';
if lastfunc=17 then result:='RoadObtacle';

if lastfunc=18 then result:='Size1x1';
if lastfunc=19 then result:='Size2x2';
if lastfunc=20 then result:='Res';

if lastfunc=21 then result:='MineBuySell';
if lastfunc=22 then result:='StandartBuySell';
if lastfunc=23 then result:='NoBuyButSell';

if lastfunc=24 then result:='StandartIcon';

if lastfunc=25 then result:='StandartIconDraw';
if lastfunc=26 then result:='UnloadPokupkaClick';
if lastfunc=27 then result:='DrawIconOnRepaint';
if lastfunc=28 then result:='DrawIconEverytime';

if lastfunc=29 then result:='SelectUnloadedPokupka';
if lastfunc=30 then result:='GetBackUnloadedPokupka';
if lastfunc=31 then result:='SelectMyUnit';
end;

function TProcPack.getMaxGFunc(id: word): TMaxGFunc;
begin
if id=25 then result:=StandartIconDraw;
if id=26 then result:=UnloadPokupkaClick;
if id=27 then result:=DrawIconOnRepaint;
if id=28 then result:=DrawIconEverytime;

if id=29 then result:=SelectUnloadedPokupka;
if id=30 then result:=GetBackUnloadedPokupka;
if id=31 then result:=SelectMyUnit;

end;

function TProcPack.LandBeachUnitTCost(TerrType: terrtpes): integer;
begin
lastfunc:=4;

result:=-1;
if TerrType[0]>0 then exit;
if TerrType[3]>0 then exit;
if TerrType[1]>0 then result:=4;
if TerrType[5]>0 then result:=4;
if TerrType[2]>0 then result:=4;
if TerrType[4]>0 then result:=4;
if TerrType[6]>0 then result:=2;

end;

function TProcPack.LandStructureTCost(TerrType: terrtpes): integer;
begin
lastfunc:=10;

result:=-1;
if TerrType[0]>0 then exit;
if TerrType[3]>0 then exit;
if TerrType[1]>0 then exit;
if TerrType[5]>0 then exit;
if TerrType[4]>0 then exit;

if TerrType[2]>0 then result:=4;
if TerrType[6]>0 then result:=2;
end;

function TProcPack.LandUnitTCost(TerrType: terrtpes): integer;
begin
lastfunc:=3;

result:=-1;
if TerrType[0]>0 then exit;
if TerrType[3]>0 then exit;
if TerrType[1]>0 then exit;
if TerrType[5]>0 then result:=4;
if TerrType[2]>0 then result:=4;
if TerrType[4]>0 then result:=4;
if TerrType[6]>0 then result:=2;

end;

function TProcPack.MineBuySell(buy: boolean=true;qty:word=1): boolean;
begin
lastfunc:=21;
if buy then showmessage('!    !'+#13#10+'        ,    .'+#13#10+'     '+#13#10+
                        'Attention! You select to buy Mine!'+#13#10+'Resourse will be guaranted place only under FIRST Mine, not under other'+#13#10+'We recommend you to buy only one mine');
if (not(buy)) and (qty=1) then begin
            showmessage('!    !'+#13#10+'    .          (  )'+#13#10+
                        'Attention! Yu select to sell you last Mine!'+#13#10+'I hope you know what you do. Good luck then.'+#13#10+'Note: start resources will be placed under one of you units (under last i think)');
end;
result:=true;
end;

function TProcPack.NoBuyButSell(buy: boolean=true; qty: word=1): boolean;
begin
lastfunc:=23;
result:=not(buy);
end;

function TProcPack.NoObtacle(TerrBefore: terrtpes): terrtpes;
begin
lastfunc:=14;
result:=TerrBefore;
end;

function TProcPack.Res(res: string; qty: word): TMxRes;
var m,f,e,h,g:word;
begin
lastfunc:=20;
m:=0;f:=0;e:=0;h:=0;g:=0;
if LowerCase(res)='gold' then g:=qty;
if LowerCase(res)='metall' then m:=qty;
if LowerCase(res)='fuel' then f:=qty;
if LowerCase(res)='energy' then e:=qty;
if LowerCase(res)='humans' then g:=qty;
result:=MXRes(m,f,e,h,g);
end;

function TProcPack.RoadObtacle(TerrBefore: terrtpes): terrtpes;
begin
lastfunc:=17;
result:=TerrBefore;
result[6]:=1;
end;

function TProcPack.SeaBeachUnitTCost(TerrType: terrtpes): integer;
begin
lastfunc:=2;

result:=-1;
if TerrType[3]>0 then exit;
if TerrType[5]>0 then exit;
if TerrType[2]>0 then exit;
if TerrType[6]>0 then exit;

if TerrType[1]>0 then result:=4;
if TerrType[0]>0 then result:=4;
if TerrType[4]>0 then result:=4;
end;

function TProcPack.SeaMineTCost(TerrType: terrtpes): integer;
begin
lastfunc:=9;

result:=-1;
if TerrType[3]>0 then exit;
if TerrType[1]>0 then exit;
if TerrType[5]>0 then exit;
if TerrType[2]>0 then exit;
if TerrType[6]>0 then exit;

if TerrType[4]>0 then exit;
if TerrType[0]>0 then result:=4;
end;

function TProcPack.SeaStructureTCost(TerrType: terrtpes): integer;
begin
lastfunc:=8;

result:=-1;
if TerrType[3]>0 then exit;
if TerrType[5]>0 then exit;
if TerrType[2]>0 then exit;
if TerrType[6]>0 then exit;

if TerrType[4]>0 then exit;
if TerrType[0]>0 then result:=4;
if TerrType[1]>0 then result:=4;
end;

function TProcPack.SeaUnitTCost(TerrType: terrtpes): integer;
begin
lastfunc:=1;

result:=-1;
if TerrType[3]>0 then exit;
if TerrType[1]>0 then exit;
if TerrType[5]>0 then exit;
if TerrType[2]>0 then exit;
if TerrType[6]>0 then exit;

if TerrType[0]>0 then result:=4;
if TerrType[4]>0 then result:=4;
end;

procedure TProcPack.SelectMyUnit(Objs: array of PObj);
var Unt:PMaxGoldObject;
var tcl:PGameMapCell;

begin
{$IFDEF BMGLOG}log('procedure TProcPack.SelectMyUnit(Objs: array of PObj);');{$ENDIF}
lastfunc:=31;
if high(objs)<0 then exit;
tcl:=PGameMapCell(objs[IDMapCell]);
unt:=tcl.getselected;
if unt<>nil then begin
   unt.click(MK_LBUTTON);
   exit;
end;
unt:=PMAXGoldObject(tcl.getnext);
if unt<>nil then unt.Click(MK_LBUTTON);
end;

procedure TProcPack.SelectUnloadedPokupka(Objs: array of PObj);
var Unt:PMaxGoldObject;
var tcl:PGameMapCell;
var plr:PNewPlayer;
begin
{$IFDEF BMGLOG}log('procedure TProcPack.SelectUnloadedPokupka(Objs: array of PObj);');{$ENDIF}
lastfunc:=29;
if high(objs)<0 then exit;
tcl:=PGameMapCell(objs[IDMapCell]);
unt:=tcl.getselected;
if unt<>nil then begin
   glsr[IDUnit]:=unt;
   GetBackUnloadedPokupka(glsr);
   exit;
end;
plr:=PnewPlayer(objs[IDCurPlayer]);
plr.units.deselectALL;
tcl.selectnext;
PBMaxDraw(objs[IDMdraw]).draw;
end;

function TProcPack.Size1x1: TMGSize;
begin
lastfunc:=18;
result:=sz(0,0);
end;

function TProcPack.Size2x2: TMGSize;
begin
lastfunc:=19;
result:=sz(0,0,1,0,0,1,1,1);
end;

function TProcPack.StandartBuySell(buy: boolean=true;qty:word=1): boolean;
begin
lastfunc:=22;
if not(buy) then result:=(qty>0) else result:=true;
end;

function TProcPack.StandartIcon(name: string;size:word;color:cardinal;mode:string): Pbitmap;
var tr:Trect;
var ss,s1:string;
var p,y:integer;
var ok:boolean;
var cl:CLRTRGBQuad;
var r,g,b:byte;
begin
lastfunc:=24;
result:=NewBitmap(size,size);
cl.color:=color;
if mode='r' then begin
  cl.rgb.rgbRed:=trunc(cl.rgb.rgbRed / 2);
  cl.rgb.rgbGreen:=trunc(cl.rgb.rgbGreen / 2);
end;
if mode='fw' then begin
     r:=cl.rgb.rgbRed;
     g:=cl.rgb.rgbGreen;
     b:=cl.rgb.rgbBlue;
     if (r<=g)and(g<=b)then begin r:=trunc((r+b+b+b)/4);g:=trunc((g+b+b+b)/4);end;
     if (r<=b)and(b<=g)then begin r:=trunc((r+g+g+g)/4);b:=trunc((b+g+g+g)/4);end;

     if (b<=g)and(g<=r)then begin b:=trunc((b+r+r+r)/4);g:=trunc((g+r+r+r)/4);end;
     if (b<=r)and(r<=g)then begin b:=trunc((b+g+g+g)/4);r:=trunc((r+g+g+g)/4);end;

     if (g<=r)and(r<=b)then begin g:=trunc((g+b+b+b)/4);r:=trunc((r+b+b+b)/4);end;
     if (g<=b)and(b<=r)then begin g:=trunc((g+r+r+r)/4);b:=trunc((b+r+r+r)/4);end;
     cl.rgb.rgbRed:=trunc(r / 1.3);
     cl.rgb.rgbGreen:=trunc(g / 1.3);
     cl.rgb.rgbBlue:=trunc(b / 1.3);
end;
color:=cl.color;
result.Canvas.Brush.Color:=color;
result.Canvas.Pen.Color:=clBlack;
tr:=result.canvas.ClipRect;
tr.left:=tr.Left+1;tr.Right:=tr.Right-1;
tr.Top:=tr.Top+1;tr.Bottom:=tr.Bottom-1;
result.Canvas.FillRect(tr);
result.Canvas.Font.FontName:='Ms SansSerif';
if size=64 then result.Canvas.Font.FontHeight:=26;
if size=128 then result.Canvas.Font.FontHeight:=40;
ok:=false;p:=1;ss:='';s1:='';y:=0;
repeat
if not(ok) then begin
   repeat
     ss:=ss+s1;
     s1:=name[p];
     if p>length(name) then ok:=true;
     inc(p);
   until (result.Canvas.TextWidth(ss+s1)>tr.Right)or(ok);
   result.Canvas.TextOUT(1,y,ss);
   y:=y+result.Canvas.TextHeight(ss);ss:='';
end;
if y>tr.Bottom then ok:=true;
until ok;
result.Canvas.Brush.BrushStyle:=bsClear;
result.Canvas.Rectangle(tr.Left-1,tr.Top-1,tr.Right+1,tr.Bottom+1);
end;

procedure TProcPack.standartIconDraw(Objs:array of PObj);
var drw:PBmaxDraw;
var unt:PUnitupgradehistory;
var tr:Trect;
var map:PGameMap;
var f1:integer;
var mappos:TXY;
begin
lastfunc:=25;
if high(objs)<0 then exit;
drw:=PBmaxDraw(objs[IDMdraw]);

mappos:=drw.pix2cellpos(drw.cursor.pixpos);

unt:=PUnitupgradehistory(objs[IDUnitInfo]);
map:=PGameMap(objs[IDGameMap]);
for f1:=1 to unt.info.size.size do begin
   if mappos.x+unt.info.size.pos[f1].x<0 then exit;
   if mappos.y+unt.info.size.pos[f1].y<0 then exit;
   if mappos.x+unt.info.size.pos[f1].x>map.mapsz.x then exit;
   if mappos.y+unt.info.size.pos[f1].y>map.mapsz.y then exit;
end;
mappos:=drw.cellpos2pix(mappos);
tr:=makerect(mappos.x,
             mappos.y,
             mappos.x+trunc(unt.info.icon.Width*drw.cellw/64),
             mappos.y+trunc(unt.info.icon.Height*drw.cellw/64));
unt.info.icon.StretchDraw(drw.flipscreen.canvas.Handle,tr);
end;

function TProcPack.StandartObtacle(TerrBefore: terrtpes): terrtpes;
begin
lastfunc:=13;
result:=TerrBefore;
result[3]:=1;
end;

function TProcPack.SurveyorUnitTCost(TerrType: terrtpes): integer;
begin
lastfunc:=6;

result:=-1;
if TerrType[3]>0 then exit;
if TerrType[0]>0 then result:=4;
if TerrType[1]>0 then result:=4;
if TerrType[5]>0 then result:=4;
if TerrType[2]>0 then result:=4;
if TerrType[4]>0 then result:=4;
if TerrType[6]>0 then result:=2;

end;

procedure TProcPack.UnloadPokupkaClick(Objs:array of PObj);
var plr:PNewPlayer;
var drw:PBmaxDraw;
var mappos:TXY;
var gm:PNewGame;
var unt:PUnitUpgradeHistory;
var unt2:PMaxGoldObject;
var LB:PControl;
var f1:integer;
{$IFDEF BMGLOG}var ss:string;gamemap:PGameMap;{$ENDIF}
begin
{$IFDEF BMGLOG}log('procedure TProcPack.UnloadPokupkaClick(Objs: array of PObj);');{$ENDIF}
lastfunc:=26;
if high(objs)<0 then exit;
plr:=PNewPlayer(objs[IDCurPlayer]);plr.units.deselectALL;
gm:=PnewGame(objs[IDGame]);
drw:=PBmaxDraw(objs[IDMdraw]);
unt:=PUnitUpgradeHistory(objs[IDUnitInfo]);
mappos:=drw.pix2cellpos(drw.cursor.pixpos);
unt2:=gm.allunit.createunitforplayer(plr,mappos,unt);
{$IFDEF BMGLOG}gamemap:=PGameMap(objs[IDGameMap]);ss:='    '+XY2Log(mappos)+#13#10+'Terrtype='+Terr2Log(gamemap.cells[mappos.x,mappos.y].terrtype)+',  ';if gamemap.positionfree(mappos,unt) then ss:=ss+'True' else ss:=ss+'False';ss:=ss+#13#10+'MaxPass='+int2str(gamemap.maxmap.getmaxpass(mappos.x,mappos.Y));showmessage(ss);{$ENDIF}
if unt2<>nil then begin
   setfunc(unt2.Func,FTLeftClickOnMyUnit,SelectUnloadedPokupka);
   LB:=Pcontrol(objs[IDCtrl]);
   for f1:=0 to high(plr.pokupki) do
      if plr.Pokupki[f1].IdinListbox=lb.CurIndex then begin

         unt2.params.gruz:=plr.Pokupki[f1].gruz;
         plr.sellpokupka(unt,f1,false,false);
         plr.pokupkiToKolListBox(LB);
      end;
   drw.cursor.clear;

   Pgamemap(objs[IDGamemap]).generatemaskfor(nil);
   drw.draw(true);
end;
end;

function TProcPack.WatrPlatformObtacle(TerrBefore: terrtpes): terrtpes;
begin
lastfunc:=16;
result:=TerrBefore;
result[0]:=0;
result[1]:=0;
result[2]:=1;
end;

end.
